#  List module (list.io)
#  Amalthea standard Io library
#  (c)2002 Martin Sandin (msandin@hotmail.com)
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

import prelude.
export
  Nil
  cons
  print_list
  string_of_list
  List_of_1 List_of_2 List_of_3 List_of_4
  List_of_5 List_of_6 List_of_7 List_of_8.


# Interface
#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #

declare Nil: -> nil_client elem_client;
  nil_client.

declare cons: -> head tail return;
  return -> nil_client elem_client;
  elem_client head tail.

declare List_of_1: -> a return;
  cons a Nil return.

declare List_of_2: -> a b return;
  List_of_1 b -> list;
  cons a list return.

declare List_of_3: -> a b c return;
  List_of_2 b c -> list;
  cons a list return.

declare List_of_4: -> a b c d return;
  List_of_3 b c d -> list;
  cons a list return.
  
declare List_of_5: -> a b c d e return;
  List_of_4 b c d e -> list;
  cons a list return.

declare List_of_6: -> a b c d e f return;
  List_of_5 b c d e f -> list;
  cons a list return.

declare List_of_7: -> a b c d e f g return;
  List_of_6 b c d e f g -> list;
  cons a list return.

declare List_of_8: -> a b c d e f g h return;
  List_of_7 b c d e f g h -> list;
  cons a list return.

declare string_of_list: -> to_str list return;
  map to_str list -> list;
  concat_strings ", " list return.
  
  
declare print_list: -> to_str list return;
  string_of_list to_str list -> str;
  print_string str;
  return.

# Demo
#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #

declare id: -> x return;
  return x.

print_string "Amalthea standard Io library: List module";
print_string "List constructed from 1,2,3:";
cons 1 Nil -> list;
cons 2 list -> list;
cons 3 list -> list;
id list -> iter;
for_each iter print_int;

print_string "Reverse list:";
reverse list -> list;
for_each iter print_int;

print_string "Collect list:";
Range 7 13 -> iter;
collect iter -> list;
for_each list print_int;

print_string "List of 7:";
List_of_7 1 2 3 4 5 6 7 -> list;
for_each list print_int;

terminate
